package com.jisco.dynamicweight.dynamicbasebatchdbconfig.controller;

import cn.hutool.core.lang.Assert;
import com.jisco.dynamicweight.dynamicbasebatchdbconfig.model.DynamicBaseBatchdbConfig;
import com.jisco.dynamicweight.dynamicbasebatchdbconfig.service.IDynamicBaseBatchdbConfigService;
import com.jisco.dynamicweight.util.ExcelUtil;
import com.jisco.dynamicweight.util.UserUtil;
import com.steerinfo.framework.controller.BaseRESTfulController;
import com.steerinfo.framework.controller.RESTfulResult;
import com.steerinfo.framework.service.pagehelper.PageList;
import com.steerinfo.framework.utils.collection.ListUtils;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import org.apache.commons.lang3.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletResponse;
import java.io.IOException;
import java.util.*;

/**
 * DynamicBaseBatchdbConfig RESTful接口：
 *
 * @author generator
 * @version 1.0-SNAPSHORT 2021-12-24 08:42
 * 类描述
 * 修订历史：
 * 日期：2021-12-24
 * 作者：generator
 * 参考：
 * 描述：DynamicBaseBatchdbConfig RESTful接口
 * @Copyright 湖南视拓信息技术股份有限公司. All rights reserved.
 * @see null
 */
@RestController
@RequestMapping("/${api.version}/dynamicbasebatchdbconfigs")
public class DynamicBaseBatchdbConfigController extends BaseRESTfulController {

    @Autowired
    IDynamicBaseBatchdbConfigService dynamicBaseBatchdbConfigService;

    @ApiOperation(value = "获取列表", notes = "分页查询")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "pageNum", value = "查询页数", required = false, dataType = "Integer"),
            @ApiImplicitParam(name = "pageSize", value = "每页记录数", required = false, dataType = "Integer")
    })
    //@RequiresPermissions("dynamicbasebatchdbconfig:view")
    @GetMapping(value = "/")
    public RESTfulResult list(@RequestParam HashMap parmas, Integer pageNum, Integer pageSize) {
        PageList<DynamicBaseBatchdbConfig> list = dynamicBaseBatchdbConfigService.queryForPage(parmas, pageNum, pageSize);
        return success(list);
    }

    @ApiOperation(value = "获取列表", notes = "分页模糊查询")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "pageNum", value = "查询页数", required = false, dataType = "Integer"),
            @ApiImplicitParam(name = "pageSize", value = "每页记录数", required = false, dataType = "Integer")
    })
    //@RequiresPermissions("dynamicbasebatchdbconfig:view")
    @GetMapping(value = "/like/")
    public RESTfulResult listLike(@RequestParam HashMap parmas, Integer pageNum, Integer pageSize) {
        PageList<DynamicBaseBatchdbConfig> list = dynamicBaseBatchdbConfigService.queryLikeForPage(parmas, pageNum, pageSize);
        return success(list);
    }

    @ApiOperation(value = "创建", notes = "根据DynamicBaseBatchdbConfig对象创建")
    @ApiImplicitParam(name = "dynamicBaseBatchdbConfig", value = "详细实体dynamicBaseBatchdbConfig", required = true, dataType = "DynamicBaseBatchdbConfig")
    //@RequiresPermissions("dynamicbasebatchdbconfig:create")
    @PostMapping(value = "/")
    public RESTfulResult add(@RequestBody DynamicBaseBatchdbConfig model) {
        checkAdd(model);
        model.setCreateManNo(UserUtil.getCurrentUserId());
        model.setCreateManName(UserUtil.getCurrentUserName());
        model.setCreateTime(new Date());
        DynamicBaseBatchdbConfig dynamicBaseBatchdbConfig = dynamicBaseBatchdbConfigService.add(model);
        return success(dynamicBaseBatchdbConfig);
    }

    private void checkAdd(DynamicBaseBatchdbConfig model) {
        Assert.isTrue(StringUtils.isNotBlank(model.getName()), "名称不能为空");
        Assert.isTrue(StringUtils.isNotBlank(model.getUrl()), "URL不能为空");
        Assert.isTrue(StringUtils.isNotBlank(model.getTableName()), "表名不能为空");
//        Assert.isTrue(StringUtils.isNotBlank(model.getCreateManNo()), "创建人不能为空");
//        Assert.isTrue(StringUtils.isNotBlank(model.getCreateManName()), "创建人名称不能为空");
        Assert.isTrue(StringUtils.isNotBlank(model.getValidFlag()), "有效标识不能为空");
    }

    @ApiOperation(value = "获取详细信息", notes = "根据url的id来获取详细信息")
    @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String")
    //@RequiresPermissions("dynamicbasebatchdbconfig:view")
    @GetMapping(value = "/{id}")
    public RESTfulResult get(@PathVariable String id) {
        DynamicBaseBatchdbConfig dynamicBaseBatchdbConfig = dynamicBaseBatchdbConfigService.getById(id);
        return success(dynamicBaseBatchdbConfig);
    }

    @ApiOperation(value = "更新详细信息", notes = "根据url的id来指定更新对象，并根据传过来的dynamicBaseBatchdbConfig信息来更新详细信息")
    @ApiImplicitParams({
            @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String"),
            @ApiImplicitParam(name = "dynamicBaseBatchdbConfig", value = "详细实体dynamicBaseBatchdbConfig", required = true, dataType = "DynamicBaseBatchdbConfig")
    })
    //@RequiresPermissions("dynamicbasebatchdbconfig:update")
    @PutMapping(value = "/{id}", produces = "application/json;charset=UTF-8")
    public RESTfulResult update(@PathVariable String id, @RequestBody DynamicBaseBatchdbConfig model) {
        model.setId(id);
        checkUpdate(model);
        model.setUpdateManNo(UserUtil.getCurrentUserId());
        model.setUpdateManName(UserUtil.getCurrentUserName());
        model.setUpdateTime(new Date());
        DynamicBaseBatchdbConfig dynamicBaseBatchdbConfig = dynamicBaseBatchdbConfigService.modify(model);
        return success(dynamicBaseBatchdbConfig);
    }

    private void checkUpdate(DynamicBaseBatchdbConfig model) {
        checkAdd(model);
//        Assert.isTrue(StringUtils.isNotBlank(model.getUpdateManNo()), "修改人不能为空");
//        Assert.isTrue(StringUtils.isNotBlank(model.getUpdateManName()), "修改人名称不能为空");
    }

    @ApiOperation(value = "删除", notes = "根据url的id来指定删除对象")
    @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String")
    //@RequiresPermissions("dynamicbasebatchdbconfig:delete")
    @DeleteMapping(value = "/{id}")//String
    public RESTfulResult delete(@PathVariable String id) {
        List<String> list = Arrays.asList(id.split(","));
        if (ListUtils.isNotEmpty(list)) {
            List<String> ids = ListUtils.convertList(list);
            dynamicBaseBatchdbConfigService.delete(ids);
        }
        return success();
    }

    @ApiOperation(value = "导出Excel", notes = "导出Excel")
    @PostMapping(value = "/exportExcel")//String
    public void exportExcel(HttpServletResponse response) throws IOException {
        List<DynamicBaseBatchdbConfig> list = dynamicBaseBatchdbConfigService.query(null);
        ExcelUtil.exportExcel(response, list, DynamicBaseBatchdbConfig.class, "皮带秤扩展配置");
    }

    @ApiOperation(value = "启用", notes = "启用")
    @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String")
    @GetMapping(value = "/enable/{id}")
    public RESTfulResult enable(@PathVariable String id) {
        boolean flag = dynamicBaseBatchdbConfigService.enable(id);
        return flag ? success(null, "操作成功") : failed(null, "操作失败");
    }

    @ApiOperation(value = "禁用", notes = "禁用")
    @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String")
    @GetMapping(value = "/disable/{id}")
    public RESTfulResult disable(@PathVariable String id) {
        boolean flag = dynamicBaseBatchdbConfigService.disable(id);
        return flag ? success(null, "操作成功") : failed(null, "操作失败");
    }
}
